package com.maroontress.testfunnel.auditor;

import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;
import javax.swing.AbstractAction;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;

/**
   ǥץ쥤ФΥɥ
*/
public class Auditor extends JFrame {

    /** ǥեȤΥݡֹ */
    public static final int DEFAULT_PORT = 30000;

    /** ץ */
    private Acceptor acceptor;

    /**
       ǥץ쥤ФΥɥޤ

       @param port ݡֹ
    */
    public Auditor(final int port) {
	super("Auditor");
	addWindowListener(new WindowAdapter()  {
	    public void windowClosing(final WindowEvent e) {
		exit(0);
	    }
	});
	setJMenuBar(createMenu());
	pack();
	setLocationByPlatform(true);

	try {
	    acceptor = new Acceptor(port);
	} catch (IOException e) {
	    e.printStackTrace();
	    System.exit(1);
	}
	acceptor.start();
    }

    /**
       ˥塼Сޤ

       @return ˥塼С
    */
    private JMenuBar createMenu()  {
	JMenuBar mb = new JMenuBar();
	JMenu menu = new JMenu("File");
	menu.add(new AbstractAction("Exit") {
	    public void actionPerformed(final ActionEvent e)  {
		exit(0);
	    }
	});
	mb.add(menu);
	return mb;
    }

    /**
       ǥץ쥤Фλޤ

       @param code λ
    */
    private void exit(final int code) {
	acceptor.dispose();
	System.exit(code);
    }

    /**
       ˡɽƽλޤ
    */
    private static void usage() {
	System.err.println("usage: java Auditor [--port=PORT]");
	System.exit(0);
    }

    /**
       ǥץ쥤Ф¹Ԥޤ

       @param av ޥɥ饤󥪥ץʸ
    */
    public static void main(final String[] av)  {
	int k, port = DEFAULT_PORT;

        for (k = 0; k < av.length && av[k].startsWith("-"); ++k) {
            if (av[k].equals("--help")) {
		usage();
            } else if (av[k].startsWith("--port=")) {
		int n = av[k].indexOf('=');
		port = Integer.parseInt(av[k].substring(n + 1));
	    } else {
		System.err.println("unknown option: " + av[k]);
		System.exit(1);
	    }
	}
	if (k < av.length) {
	    usage();
	}
	(new Auditor(port)).setVisible(true);
    }
}
